SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Mike "Wolf" Gilbert
-- Create date: 
-- Description:	
-- =============================================


USE MSE6DB
GO

/****** Object:  Trigger [ChannelsTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[ChannelsTrigger]'))
DROP TRIGGER [ServiceEngine].[ChannelsTrigger]

/****** Object:  Trigger [EndpointsTrigger]    Script Date: 11/02/2005 10:19:21 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[EndpointsTrigger]'))
DROP TRIGGER [ServiceEngine].[EndpointsTrigger]

/****** Object:  Trigger RuntimeServers_EndpointsTrigger    Script Date: 11/02/2005 10:19:21 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[RuntimeServers_EndpointsTrigger]'))
DROP TRIGGER [ServiceEngine].[RuntimeServers_EndpointsTrigger]

/****** Object:  Trigger [RuntimeServersTrigger]    Script Date: 11/02/2005 10:19:21 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[RuntimeServersTrigger]'))
DROP TRIGGER [ServiceEngine].[RuntimeServersTrigger]

/****** Object:  Trigger [MessagePartsTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[MessagePartsTrigger]'))
DROP TRIGGER [ServiceEngine].[MessagePartsTrigger]

/****** Object:  Trigger [OperationsTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[OperationsTrigger]'))
DROP TRIGGER [ServiceEngine].[OperationsTrigger]

/****** Object:  Trigger [OperationVersionsTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[OperationVersionsTrigger]'))
DROP TRIGGER [ServiceEngine].[OperationVersionsTrigger]

/****** Object:  Trigger [PoliciesTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[PoliciesTrigger]'))
DROP TRIGGER [ServiceEngine].[PoliciesTrigger]

/****** Object:  Trigger [SchemasTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[SchemasTrigger]'))
DROP TRIGGER [ServiceEngine].[SchemasTrigger]

/****** Object:  Trigger [Services_EndpointsTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[Endpoints_PublishedOperationsTrigger]'))
DROP TRIGGER [ServiceEngine].[Endpoints_PublishedOperationsTrigger]

/****** Object:  Trigger [Services_EndpointsTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[Endpoints_AssociatedOperationsTrigger]'))
DROP TRIGGER [ServiceEngine].[Endpoints_AssociatedOperationsTrigger]

/****** Object:  Trigger [BindingsTrigger]    Script Date: 11/02/2005 11:57:29 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[ServiceEngine].[Bindings]'))
DROP TRIGGER [ServiceEngine].[BindingsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].RuntimeServers_EndpointsTrigger 
   ON  [ServiceEngine].RuntimeServers_Endpoints 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[RuntimeServersEndpointsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].RuntimeServersTrigger 
   ON  [ServiceEngine].RuntimeServers 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[RuntimeServersTrigger]

GO

CREATE TRIGGER  [ServiceEngine].EndpointsTrigger 
   ON  [ServiceEngine].EndPoints 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[EndpointsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].MessagePartsTrigger 
   ON  [ServiceEngine].MessageParts 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[MessagePartsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].OperationsTrigger 
   ON  [ServiceEngine].Operations 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[OperationsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].OperationVersionsTrigger 
   ON  [ServiceEngine].OperationVersions 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[OperationVersionsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].PoliciesTrigger 
   ON  [ServiceEngine].Policies 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[PoliciesTrigger]

GO

CREATE TRIGGER  [ServiceEngine].SchemasTrigger 
   ON  [ServiceEngine].Schemas 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[SchemasTrigger]

GO

CREATE TRIGGER  [ServiceEngine].ChannelsTrigger 
   ON  [ServiceEngine].Channels 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[ChannelsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].Endpoints_PublishedOperationsTrigger 
   ON  [ServiceEngine].Endpoints_PublishedOperations 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[Endpoints_PublishedOperationsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].Endpoints_AssociatedOperationsTrigger 
   ON  [ServiceEngine].Endpoints_AssociatedOperations 
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[Endpoints_AssociatedOperationsTrigger]

GO

CREATE TRIGGER  [ServiceEngine].BindingsTrigger 
   ON  [ServiceEngine].Bindings
   AFTER INSERT,DELETE,UPDATE
AS EXTERNAL NAME
[ClrTriggers].[Microsoft.MSE.Repository.Triggers.CLRTriggers].[BindingsTrigger]

GO


