using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace Microsoft.MSE.ExceptionManagement
{
    public abstract class ExceptionBase : Exception, ISerializable
    {
        #region properties
        public DateTime dateTime = DateTime.Now;
        public string machineName = Environment.MachineName;
        protected string mseComponent;
        #endregion

        public ExceptionBase()
            :base()
        {
        }

        public ExceptionBase(string message)
            : base(message)
        {
        }

        public ExceptionBase(string message, Exception inner)
            : base(message, inner)
        {

        }

        protected ExceptionBase(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {

        }
    }
}
