﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.MSE.Logging;

namespace Microsoft.MSE.Logging
{
    /// <summary>
    /// Helper class that formats common logging messages.
    /// </summary>
    public static class LoggingMessage
    {
        /// <summary>
        /// Formatted logging message for entering a method
        /// </summary>
        /// <param name="methodName">Name of the method entering</param>
        /// <returns>The formatted log message</returns>
        public static string EnterMethod(string methodName)
        {
            return string.Format(Messages.EnterMethod, methodName);
        }

        /// <summary>
        /// Formatted logging message for exiting a method
        /// </summary>
        /// <param name="methodName">Name of the method that is being exited</param>
        /// <returns>The formatted log message</returns>
        public static string ExitMethod(string methodName)
        {
            return string.Format(Messages.ExitMethod, methodName);
        }

        /// <summary>
        /// A formatted message that explains an exception has occured and to see the log for details.
        /// </summary>
        /// <returns>The formatted log message</returns>
        public static string Exception()
        {
            return Messages.Exception;
        }
    }
}