﻿-- =================================================================
-- ServiceEngine.AssignAssociatedOperationVersionToEndpoint.proc.sql
-- =================================================================
CREATE PROCEDURE [ServiceEngine].[AssignAssociatedOperationVersionToEndpoint]
	@OperationVersionID uniqueidentifier,
	@EndpointID uniqueidentifier
AS
BEGIN
	DECLARE @ErrorMessage NVARCHAR(4000);
	DECLARE @ErrorSeverity INT;
	DECLARE @ErrorState INT;
	SET NOCOUNT ON;

	BEGIN TRY
		BEGIN TRANSACTION

		DECLARE @ID as uniqueidentifier

		SET @ID = newid();

		INSERT	ServiceEngine.Endpoints_AssociatedOperations (Endpoints_AssociatedOperationsID, OperationVersionID, EndpointID)
		VALUES	(@ID, @OperationVersionID, @EndpointID)

		COMMIT TRANSACTION
	END TRY
	BEGIN CATCH
		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();

		IF XACT_STATE() <> 0 ROLLBACK TRANSACTION;

		RAISERROR (@ErrorMessage, 
				   @ErrorSeverity,
				   1);
	END CATCH
END


