﻿-- =============================================
-- Author:		Wolf Gilbert
-- Create date: 7/16/06
-- Description:	
-- =============================================
CREATE PROCEDURE [ServiceEngine].[GetEndpoint]
	@ID uniqueidentifier
AS
BEGIN
	SET NOCOUNT ON;

	SELECT	N.[EntityID] as EndpointID, N.[EntityName] as Path, E.BindingID, E.PolicyID, N.EntityDescription as Description, 
		E.NamespaceURI, E.TestCallsAccepted, E.AutoOperationPubUpdate, E.AutoOperationActivationUpdate, E.Configuration, E.ServiceName, E.Port
	FROM	[ServiceEngine].Endpoints E
	JOIN	[ServiceEngine].Names N on N.[EntityID] = E.EndpointID and N.[EntityTypeID] = 2
	WHERE	E.EndpointID = @ID

END


