﻿-- =============================================
-- Author:		William Oellermann
-- Create date: 12/6/06
-- Description:	
-- =============================================
CREATE PROCEDURE [ServiceEngine].[GetRuntimeServer]
	@ID uniqueidentifier
AS
BEGIN
	SET NOCOUNT ON;

	SELECT	N.[EntityID] as RuntimeServerID, 
			N.[EntityName] as Name, 
			A.CatalogURI, 
			A.CatalogBindingID, 
			A.NotificationURI, 
			A.NotificationBindingID, 
			A.BrokerURI, 
			A.BrokerBindingID, 
			A.ListenerURI, 
			A.ListenerBindingID,
			A.HostName, 
			N.EntityDescription as Description,
			A.PolicyID,
			A.ReceiveNotifications
	FROM	[ServiceEngine].RuntimeServers A
	JOIN	[ServiceEngine].Names N on N.[EntityID] = A.RuntimeServerID and N.[EntityTypeID] = 0
	WHERE	A.RuntimeServerID = @ID

END


