﻿CREATE PROCEDURE [ServiceEngine].[ListAssociatedOperationsForEndpoint]
	@EndpointID uniqueidentifier
AS
BEGIN
	SET NOCOUNT ON;

SELECT	OV.[OperationVersionID] as ID, N.[EntityName] as OpName, OV.[VersionMajor] as Major, OV.[VersionMinor] as Minor, OV.[VersionBuild] as Build, OV.[VersionQFE] as QFE
	FROM	[ServiceEngine].Endpoints_AssociatedOperations AO 
	JOIN	[ServiceEngine].OperationVersions OV on AO.OperationVersionID = OV.OperationVersionID
	JOIN	[ServiceEngine].Names N on OV.OperationID = N.EntityID
	WHERE	AO.EndpointID = @EndpointID
	Order By N.[EntityName]

END


