﻿CREATE PROCEDURE [ServiceEngine].[ListEndpointsForBindingID]
	@BindingID uniqueidentifier
AS
BEGIN
	SET NOCOUNT ON;

	SELECT	N.[EntityID] as EndpointID, N.[EntityName] as URI, N.EntityDescription as Description
	FROM	[ServiceEngine].Names N
	INNER JOIN [ServiceEngine].EndPoints EP ON N.EntityID = EP.EndpointID
	WHERE	N.[EntityTypeID] = 2 AND EP.BindingID = @BindingID
	Order by N.[EntityName]
END


