﻿CREATE PROCEDURE [ServiceEngine].[ListOperationVersionsBySchema]
	@SchemaID uniqueidentifier
AS
BEGIN
	SET NOCOUNT ON;

	SELECT	DISTINCT OV.OperationVersionID as ID, OV.VersionMajor, OV.VersionMinor, OV.VersionBuild, OV.VersionQFE --, OV.Description
	FROM	[ServiceEngine].OperationVersions OV
	JOIN	[ServiceEngine].MessageParts MP on OV.OperationVersionID = MP.OperationVersionID
	JOIN	[ServiceEngine].SchemaObjects SO on SO.SchemaObjectID = MP.SchemaObjectID
	WHERE	SO.SchemaID = @SchemaID 
	AND		SO.DateRevised = NULL -- This is for the latest node
END
