﻿CREATE PROCEDURE [ServiceEngine].[ListResourcesForBindingID]
	@BindingID uniqueidentifier
AS
BEGIN
	SET NOCOUNT ON;

	SELECT	N.[EntityID] as ResourceID, N.[EntityName] as [Name], N.EntityDescription as Description
	FROM	[ServiceEngine].Names N
	INNER JOIN [ServiceEngine].Resources R ON N.EntityID = R.ResourceID
	WHERE	N.[EntityTypeID] = 16 AND R.BindingID = @BindingID
	Order by N.[EntityName]
END


