﻿CREATE PROCEDURE [ServiceEngine].[ListResourcesForSchemaObject]
@SchemaObjectID UNIQUEIDENTIFIER
AS
BEGIN
	SET NOCOUNT ON;

	SELECT	N.[EntityID] as ResourceID, N.[EntityName] as [Name]
	FROM	[ServiceEngine].Names N
	INNER JOIN [ServiceEngine].Resources R ON N.EntityID = R.ResourceID
	WHERE	N.[EntityTypeID] = 16 AND (R.RequestEntity = @SchemaObjectID OR R.ResponseEntity = @SchemaObjectID)
	Order by N.[EntityName]
END