﻿CREATE PROCEDURE [ServiceEngine].[ListRuntimeEventDataForSystemID]
	@SystemID uniqueidentifier
AS
BEGIN
	SET NOCOUNT ON
	SELECT DISTINCT rse.RuntimeServerID, rse.EndpointID, ov.OperationID
	FROM ServiceEngine.OperationVersions ov
		INNER JOIN ServiceEngine.Endpoints_AssociatedOperations eao ON eao.OperationVersionID = ov.OperationVersionID
		INNER JOIN ServiceEngine.RuntimeServers_Endpoints rse ON eao.EndpointID = rse.EndpointID
		INNER JOIN ServiceEngine.Resources r ON r.ResourceID = ov.ResourceID
		INNER JOIN ServiceEngine.SystemInstances si ON si.InstanceID = r.InstanceID
	WHERE si.SystemID = @SystemID
	UNION
	SELECT DISTINCT rse.RuntimeServerID, rse.EndpointID, ov.OperationID
	FROM ServiceEngine.OperationVersions ov
		INNER JOIN ServiceEngine.Endpoints_PublishedOperations epo ON epo.OperationVersionID = ov.OperationVersionID
		INNER JOIN ServiceEngine.RuntimeServers_Endpoints rse ON epo.EndpointID = rse.EndpointID
		INNER JOIN ServiceEngine.Resources r ON r.ResourceID = ov.ResourceID
		INNER JOIN ServiceEngine.SystemInstances si ON si.InstanceID = r.InstanceID
	WHERE si.SystemID = @SystemID
END
