﻿CREATE PROCEDURE [ServiceEngine].[ListSchemaObjectsBySchemaID]
@SchemaID UNIQUEIDENTIFIER
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
  SELECT 
		SO.[SchemaObjectID],
		SO.[SchemaObjectName],
		SO.[SchemaObjectType],
		SO.[SchemaObjectXml],
		SO.DataEntityID,
		N.EntityName,
		SO.[DateRevised]
	FROM 
		[SchemaObjects] SO JOIN [Names] N ON SO.SchemaID = N.EntityID
	WHERE
		SO.SchemaID = @SchemaID AND DateRevised IS NULL
END

