﻿CREATE PROCEDURE [ServiceEngine].[RemoveBindingElementsFromBinding]
	@BindingID uniqueidentifier,
	@BindingElementID uniqueidentifier,
	@ElementOrder tinyint
AS
BEGIN
	DECLARE @ErrorMessage NVARCHAR(4000);
	DECLARE @ErrorSeverity INT;
	DECLARE @ErrorState INT;
	SET NOCOUNT ON;

	BEGIN TRY
		BEGIN TRANSACTION

		DELETE	ServiceEngine.Bindings_BindingElements
		WHERE	BindingID = @BindingID
		AND		BindingElementID = @BindingElementID
		AND		ElementOrder = @ElementOrder		

		COMMIT TRANSACTION
	END TRY
	BEGIN CATCH
		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();

		IF XACT_STATE() <> 0 ROLLBACK TRANSACTION;

		RAISERROR (@ErrorMessage, 
				   @ErrorSeverity,
				   1);
	END CATCH
END


