﻿CREATE PROCEDURE [ServiceEngine].[RemoveEndpointFromRuntimeServer]
	@RuntimeServerID uniqueidentifier,
	@EndpointID uniqueidentifier
AS
BEGIN
 DECLARE @ErrorMessage NVARCHAR(4000);
 DECLARE @ErrorSeverity INT;
 DECLARE @ErrorState INT;
 SET NOCOUNT ON;

 BEGIN TRY
  BEGIN TRANSACTION

  DELETE ServiceEngine.RuntimeServers_Endpoints 
  WHERE RuntimeServerID = @RuntimeServerID AND EndpointID = @EndpointID

  COMMIT TRANSACTION
 END TRY
 BEGIN CATCH
  SELECT 
   @ErrorMessage = ERROR_MESSAGE(),
   @ErrorSeverity = ERROR_SEVERITY(),
   @ErrorState = ERROR_STATE();

  IF XACT_STATE() <> 0 ROLLBACK TRANSACTION;

  RAISERROR (@ErrorMessage, 
       @ErrorSeverity,
       1);
 END CATCH
 END


