﻿CREATE PROCEDURE [ServiceEngine].[UpdateEntityGroup]
 @Name nvarchar(400),
 @Description ntext = null, 
 @ID uniqueidentifier
AS
BEGIN
 DECLARE @ErrorMessage NVARCHAR(4000);
 DECLARE @ErrorSeverity INT;
 DECLARE @ErrorState INT;
 SET NOCOUNT ON;

 BEGIN TRY
  BEGIN TRANSACTION
  
  UPDATE ServiceEngine.Names
  SET  EntityName = @Name,
    EntityDescription = @Description    
  WHERE EntityID = @ID


  COMMIT TRANSACTION
 END TRY
 BEGIN CATCH
  SELECT 
   @ErrorMessage = ERROR_MESSAGE(),
   @ErrorSeverity = ERROR_SEVERITY(),
   @ErrorState = ERROR_STATE();

  IF XACT_STATE() <> 0 ROLLBACK TRANSACTION;

  RAISERROR (@ErrorMessage, 
       @ErrorSeverity,
       1);
 END CATCH

END