﻿CREATE PROCEDURE [ServiceEngine].[UpdateSchemaImport]
	@SchemaImportID uniqueidentifier,
	@ImportNamespace NVARCHAR(256)
AS
BEGIN
	DECLARE @ErrorMessage NVARCHAR(4000);
	DECLARE @ErrorSeverity INT;
	DECLARE @ErrorState INT;
	
	SET NOCOUNT ON;

	BEGIN TRY
		BEGIN				
			BEGIN TRANSACTION
				UPDATE ServiceEngine.SchemaImports
				SET ImportNamespace = @ImportNamespace
				WHERE SchemaImportID = @SchemaImportID
			COMMIT TRANSACTION
		END
	END TRY
	BEGIN CATCH
		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();

		IF XACT_STATE() <> 0 ROLLBACK TRANSACTION;

		RAISERROR (@ErrorMessage, 
				   @ErrorSeverity,
				   1);
	END CATCH
END
