﻿CREATE PROCEDURE [ServiceEngine].[UpdateSystem]
	@Name nvarchar(400),
	@OwnerName nvarchar(200) = null,
	@Description ntext = null,		
	@OwnerContact nvarchar(200) = null,
	@Location nvarchar(max) = null,
	@PolicyID uniqueidentifier = null,
	@URI NVARCHAR (500)=NULL,
	@ID uniqueidentifier
AS
BEGIN
	DECLARE @ErrorMessage NVARCHAR(4000);
	DECLARE @ErrorSeverity INT;
	DECLARE @ErrorState INT;
	SET NOCOUNT ON;

	BEGIN TRY
		BEGIN TRANSACTION

		UPDATE	ServiceEngine.Systems 
		SET		OwnerName = @OwnerName,
				OwnerContact = @OwnerContact,
				Location = @Location,
				PolicyID = @PolicyID,
				URI = @URI
		WHERE	SystemID = @ID

		UPDATE	ServiceEngine.Names
		SET		EntityName = @Name,
				EntityDescription = @Description
		WHERE	EntityID = @ID and EntityTypeID = 12

		COMMIT TRANSACTION
	END TRY
	BEGIN CATCH
		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();

		IF XACT_STATE() <> 0 ROLLBACK TRANSACTION;

		RAISERROR (@ErrorMessage, 
				   @ErrorSeverity,
				   1);
	END CATCH

END