﻿CREATE XML SCHEMA COLLECTION [ServiceEngine].[WCFBindingsSchema] AS N'
<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
	xmlns:t="http://schemas.serviceplatform.microsoft.com/MSE/Catalog" 
	elementFormDefault="unqualified"
	attributeFormDefault="unqualified">
	<xsd:element name="bindings">
		<xsd:complexType>
			<xsd:complexContent>
				<xsd:restriction base="xsd:anyType">
					<xsd:choice minOccurs="0" maxOccurs="unbounded">
						<xsd:element name="basicHttpBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="readerQuotas">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="maxDepth">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxStringContentLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxArrayLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBytesPerRead">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxNameTableCharCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="transport">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="clientCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Basic" />
																												<xsd:enumeration value="Digest" />
																												<xsd:enumeration value="Ntlm" />
																												<xsd:enumeration value="Windows" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="proxyCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Basic" />
																												<xsd:enumeration value="Digest" />
																												<xsd:enumeration value="Ntlm" />
																												<xsd:enumeration value="Windows" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="realm" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																					<xsd:element name="message">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="clientCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="UserName" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="algorithmSuite" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Transport" />
																							<xsd:enumeration value="Message" />
																							<xsd:enumeration value="TransportWithMessageCredential" />
																							<xsd:enumeration value="TransportCredentialOnly" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="allowCookies" type="boolean_type" />
															<xsd:attribute name="bypassProxyOnLocal" type="boolean_type" />
															<xsd:attribute name="hostNameComparisonMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="StrongWildcard" />
																		<xsd:enumeration value="Exact" />
																		<xsd:enumeration value="WeakWildcard" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferPoolSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="messageEncoding">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Text" />
																		<xsd:enumeration value="Mtom" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="proxyAddress" type="xsd:string" />
															<xsd:attribute name="textEncoding" type="xsd:string" />
															<xsd:attribute name="transferMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Buffered" />
																		<xsd:enumeration value="Streamed" />
																		<xsd:enumeration value="StreamedRequest" />
																		<xsd:enumeration value="StreamedResponse" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="useDefaultWebProxy" type="boolean_type" />
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="customBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="binaryMessageEncoding">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="readerQuotas">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="maxDepth">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxStringContentLength">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxArrayLength">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxBytesPerRead">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxNameTableCharCount">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="maxReadPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxWritePoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxSessionSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="compositeDuplex">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="clientBaseAddress" type="xsd:string" />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="oneWay">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="channelPoolSettings">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="idleTimeout">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="leaseTimeout">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxOutboundChannelsPerEndpoint">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="1" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="maxAcceptedChannels">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="packetRoutable" type="boolean_type" />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="httpTransport">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="allowCookies" type="boolean_type" />
																				<xsd:attribute name="authenticationScheme">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Digest" />
																							<xsd:enumeration value="Negotiate" />
																							<xsd:enumeration value="Ntlm" />
																							<xsd:enumeration value="IntegratedWindowsAuthentication" />
																							<xsd:enumeration value="Basic" />
																							<xsd:enumeration value="Anonymous" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="bypassProxyOnLocal" type="boolean_type" />
																				<xsd:attribute name="hostNameComparisonMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="StrongWildcard" />
																							<xsd:enumeration value="Exact" />
																							<xsd:enumeration value="WeakWildcard" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="keepAliveEnabled" type="boolean_type" />
																				<xsd:attribute name="maxBufferSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="proxyAddress" type="xsd:string" />
																				<xsd:attribute name="proxyAuthenticationScheme">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Digest" />
																							<xsd:enumeration value="Negotiate" />
																							<xsd:enumeration value="Ntlm" />
																							<xsd:enumeration value="IntegratedWindowsAuthentication" />
																							<xsd:enumeration value="Basic" />
																							<xsd:enumeration value="Anonymous" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="realm" type="xsd:string" />
																				<xsd:attribute name="transferMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Buffered" />
																							<xsd:enumeration value="Streamed" />
																							<xsd:enumeration value="StreamedRequest" />
																							<xsd:enumeration value="StreamedResponse" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="unsafeConnectionNtlmAuthentication" type="boolean_type" />
																				<xsd:attribute name="useDefaultWebProxy" type="boolean_type" />
																				<xsd:attribute name="manualAddressing" type="boolean_type" />
																				<xsd:attribute name="maxBufferPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxReceivedMessageSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="httpsTransport">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="requireClientCertificate" type="boolean_type" />
																				<xsd:attribute name="allowCookies" type="boolean_type" />
																				<xsd:attribute name="authenticationScheme">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Digest" />
																							<xsd:enumeration value="Negotiate" />
																							<xsd:enumeration value="Ntlm" />
																							<xsd:enumeration value="IntegratedWindowsAuthentication" />
																							<xsd:enumeration value="Basic" />
																							<xsd:enumeration value="Anonymous" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="bypassProxyOnLocal" type="boolean_type" />
																				<xsd:attribute name="hostNameComparisonMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="StrongWildcard" />
																							<xsd:enumeration value="Exact" />
																							<xsd:enumeration value="WeakWildcard" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="keepAliveEnabled" type="boolean_type" />
																				<xsd:attribute name="maxBufferSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="proxyAddress" type="xsd:string" />
																				<xsd:attribute name="proxyAuthenticationScheme">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Digest" />
																							<xsd:enumeration value="Negotiate" />
																							<xsd:enumeration value="Ntlm" />
																							<xsd:enumeration value="IntegratedWindowsAuthentication" />
																							<xsd:enumeration value="Basic" />
																							<xsd:enumeration value="Anonymous" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="realm" type="xsd:string" />
																				<xsd:attribute name="transferMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Buffered" />
																							<xsd:enumeration value="Streamed" />
																							<xsd:enumeration value="StreamedRequest" />
																							<xsd:enumeration value="StreamedResponse" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="unsafeConnectionNtlmAuthentication" type="boolean_type" />
																				<xsd:attribute name="useDefaultWebProxy" type="boolean_type" />
																				<xsd:attribute name="manualAddressing" type="boolean_type" />
																				<xsd:attribute name="maxBufferPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxReceivedMessageSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="msmqIntegration">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="msmqTransportSecurity">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="msmqAuthenticationMode">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="WindowsDomain" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqEncryptionAlgorithm">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="RC4Stream" />
																												<xsd:enumeration value="Aes" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqProtectionLevel">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Sign" />
																												<xsd:enumeration value="EncryptAndSign" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqSecureHashAlgorithm">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="MD5" />
																												<xsd:enumeration value="Sha1" />
																												<xsd:enumeration value="Sha256" />
																												<xsd:enumeration value="Sha512" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="serializationFormat">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Xml" />
																							<xsd:enumeration value="Binary" />
																							<xsd:enumeration value="ActiveX" />
																							<xsd:enumeration value="ByteArray" />
																							<xsd:enumeration value="Stream" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="customDeadLetterQueue" type="xsd:string" />
																				<xsd:attribute name="deadLetterQueue">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="System" />
																							<xsd:enumeration value="Custom" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="durable" type="boolean_type" />
																				<xsd:attribute name="exactlyOnce" type="boolean_type" />
																				<xsd:attribute name="maxRetryCycles">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="receiveErrorHandling">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Fault" />
																							<xsd:enumeration value="Drop" />
																							<xsd:enumeration value="Reject" />
																							<xsd:enumeration value="Move" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="receiveRetryCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="retryCycleDelay">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="timeToLive">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="useSourceJournal" type="boolean_type" />
																				<xsd:attribute name="useMsmqTracing" type="boolean_type" />
																				<xsd:attribute name="manualAddressing" type="boolean_type" />
																				<xsd:attribute name="maxBufferPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxReceivedMessageSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="msmqTransport">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="msmqTransportSecurity">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="msmqAuthenticationMode">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="WindowsDomain" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqEncryptionAlgorithm">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="RC4Stream" />
																												<xsd:enumeration value="Aes" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqProtectionLevel">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Sign" />
																												<xsd:enumeration value="EncryptAndSign" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqSecureHashAlgorithm">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="MD5" />
																												<xsd:enumeration value="Sha1" />
																												<xsd:enumeration value="Sha256" />
																												<xsd:enumeration value="Sha512" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="maxPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="queueTransferProtocol">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Native" />
																							<xsd:enumeration value="Srmp" />
																							<xsd:enumeration value="SrmpSecure" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="useActiveDirectory" type="boolean_type" />
																				<xsd:attribute name="customDeadLetterQueue" type="xsd:string" />
																				<xsd:attribute name="deadLetterQueue">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="System" />
																							<xsd:enumeration value="Custom" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="durable" type="boolean_type" />
																				<xsd:attribute name="exactlyOnce" type="boolean_type" />
																				<xsd:attribute name="maxRetryCycles">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="receiveErrorHandling">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Fault" />
																							<xsd:enumeration value="Drop" />
																							<xsd:enumeration value="Reject" />
																							<xsd:enumeration value="Move" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="receiveRetryCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="retryCycleDelay">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="timeToLive">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="useSourceJournal" type="boolean_type" />
																				<xsd:attribute name="useMsmqTracing" type="boolean_type" />
																				<xsd:attribute name="manualAddressing" type="boolean_type" />
																				<xsd:attribute name="maxBufferPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxReceivedMessageSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="mtomMessageEncoding">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="readerQuotas">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="maxDepth">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxStringContentLength">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxArrayLength">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxBytesPerRead">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxNameTableCharCount">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="maxReadPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxWritePoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="messageVersion" type="xsd:string" />
																				<xsd:attribute name="maxBufferSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="writeEncoding" type="xsd:string" />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="namedPipeTransport">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="connectionPoolSettings">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="groupName" type="xsd:string" />
																									<xsd:attribute name="idleTimeout">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxOutboundConnectionsPerEndpoint">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="connectionBufferSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="hostNameComparisonMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="StrongWildcard" />
																							<xsd:enumeration value="Exact" />
																							<xsd:enumeration value="WeakWildcard" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="channelInitializationTimeout">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBufferSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxPendingConnections">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxOutputDelay">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxPendingAccepts">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="transferMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Buffered" />
																							<xsd:enumeration value="Streamed" />
																							<xsd:enumeration value="StreamedRequest" />
																							<xsd:enumeration value="StreamedResponse" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="manualAddressing" type="boolean_type" />
																				<xsd:attribute name="maxBufferPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxReceivedMessageSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="peerTransport">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="security">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:choice minOccurs="0" maxOccurs="unbounded">
																										<xsd:element name="transport">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:sequence />
																														<xsd:attribute name="credentialType">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:enumeration value="Password" />
																																	<xsd:enumeration value="Certificate" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																									</xsd:choice>
																									<xsd:attribute name="mode">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Transport" />
																												<xsd:enumeration value="Message" />
																												<xsd:enumeration value="TransportWithMessageCredential" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="listenIPAddress" type="xsd:string" />
																				<xsd:attribute name="maxBufferPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxReceivedMessageSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="port">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="65535" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="pnrpPeerResolver">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="privacyNoticeAt">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="url" type="xsd:string" />
																				<xsd:attribute name="version">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="reliableSession">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="acknowledgementInterval">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="flowControlEnabled" type="boolean_type" />
																				<xsd:attribute name="inactivityTimeout">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxPendingChannels">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="16384" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxRetryCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxTransferWindowSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="4096" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="ordered" type="boolean_type" />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="secureConversationBootstrap">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:choice minOccurs="0" maxOccurs="unbounded">
																										<xsd:element name="issuedTokenParameters">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="additionalRequestParameters">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:element name="xmlElement">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="xmlElement" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																			</xsd:choice>
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="claimTypeRequirements">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:element name="add">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="claimType" type="xsd:string" use="required" />
																																								<xsd:attribute name="isOptional" type="boolean_type" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="remove">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="claimType" type="xsd:string" use="required" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="clear">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType" />
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																			</xsd:choice>
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="issuer">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:element name="headers">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																									<xsd:any processContents="skip" />
																																								</xsd:choice>
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="identity">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																									<xsd:element name="userPrincipalName">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="value" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="servicePrincipalName">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="value" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="dns">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="value" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="rsa">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="value" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="certificate">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="encodedValue" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="certificateReference">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="storeName">
																																														<xsd:simpleType>
																																															<xsd:restriction base="xsd:string">
																																																<xsd:enumeration value="AddressBook" />
																																																<xsd:enumeration value="AuthRoot" />
																																																<xsd:enumeration value="CertificateAuthority" />
																																																<xsd:enumeration value="Disallowed" />
																																																<xsd:enumeration value="My" />
																																																<xsd:enumeration value="Root" />
																																																<xsd:enumeration value="TrustedPeople" />
																																																<xsd:enumeration value="TrustedPublisher" />
																																															</xsd:restriction>
																																														</xsd:simpleType>
																																													</xsd:attribute>
																																													<xsd:attribute name="storeLocation">
																																														<xsd:simpleType>
																																															<xsd:restriction base="xsd:string">
																																																<xsd:enumeration value="CurrentUser" />
																																																<xsd:enumeration value="LocalMachine" />
																																															</xsd:restriction>
																																														</xsd:simpleType>
																																													</xsd:attribute>
																																													<xsd:attribute name="x509FindType">
																																														<xsd:simpleType>
																																															<xsd:restriction base="xsd:string">
																																																<xsd:enumeration value="FindByThumbprint" />
																																																<xsd:enumeration value="FindBySubjectName" />
																																																<xsd:enumeration value="FindBySubjectDistinguishedName" />
																																																<xsd:enumeration value="FindByIssuerName" />
																																																<xsd:enumeration value="FindByIssuerDistinguishedName" />
																																																<xsd:enumeration value="FindBySerialNumber" />
																																																<xsd:enumeration value="FindByTimeValid" />
																																																<xsd:enumeration value="FindByTimeNotYetValid" />
																																																<xsd:enumeration value="FindByTimeExpired" />
																																																<xsd:enumeration value="FindByTemplateName" />
																																																<xsd:enumeration value="FindByApplicationPolicy" />
																																																<xsd:enumeration value="FindByCertificatePolicy" />
																																																<xsd:enumeration value="FindByExtension" />
																																																<xsd:enumeration value="FindByKeyUsage" />
																																																<xsd:enumeration value="FindBySubjectKeyIdentifier" />
																																															</xsd:restriction>
																																														</xsd:simpleType>
																																													</xsd:attribute>
																																													<xsd:attribute name="findValue" type="xsd:string" />
																																													<xsd:attribute name="isChainIncluded" type="boolean_type" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																								</xsd:choice>
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																			</xsd:choice>
																																			<xsd:attribute name="binding" type="xsd:string" />
																																			<xsd:attribute name="bindingConfiguration" type="xsd:string" />
																																			<xsd:attribute name="address" type="xsd:string" use="required" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="issuerMetadata">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:element name="headers">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																									<xsd:any processContents="skip" />
																																								</xsd:choice>
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="identity">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																									<xsd:element name="userPrincipalName">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="value" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="servicePrincipalName">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="value" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="dns">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="value" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="rsa">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="value" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="certificate">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="encodedValue" type="xsd:string" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																									<xsd:element name="certificateReference">
																																										<xsd:complexType>
																																											<xsd:complexContent>
																																												<xsd:restriction base="xsd:anyType">
																																													<xsd:sequence />
																																													<xsd:attribute name="storeName">
																																														<xsd:simpleType>
																																															<xsd:restriction base="xsd:string">
																																																<xsd:enumeration value="AddressBook" />
																																																<xsd:enumeration value="AuthRoot" />
																																																<xsd:enumeration value="CertificateAuthority" />
																																																<xsd:enumeration value="Disallowed" />
																																																<xsd:enumeration value="My" />
																																																<xsd:enumeration value="Root" />
																																																<xsd:enumeration value="TrustedPeople" />
																																																<xsd:enumeration value="TrustedPublisher" />
																																															</xsd:restriction>
																																														</xsd:simpleType>
																																													</xsd:attribute>
																																													<xsd:attribute name="storeLocation">
																																														<xsd:simpleType>
																																															<xsd:restriction base="xsd:string">
																																																<xsd:enumeration value="CurrentUser" />
																																																<xsd:enumeration value="LocalMachine" />
																																															</xsd:restriction>
																																														</xsd:simpleType>
																																													</xsd:attribute>
																																													<xsd:attribute name="x509FindType">
																																														<xsd:simpleType>
																																															<xsd:restriction base="xsd:string">
																																																<xsd:enumeration value="FindByThumbprint" />
																																																<xsd:enumeration value="FindBySubjectName" />
																																																<xsd:enumeration value="FindBySubjectDistinguishedName" />
																																																<xsd:enumeration value="FindByIssuerName" />
																																																<xsd:enumeration value="FindByIssuerDistinguishedName" />
																																																<xsd:enumeration value="FindBySerialNumber" />
																																																<xsd:enumeration value="FindByTimeValid" />
																																																<xsd:enumeration value="FindByTimeNotYetValid" />
																																																<xsd:enumeration value="FindByTimeExpired" />
																																																<xsd:enumeration value="FindByTemplateName" />
																																																<xsd:enumeration value="FindByApplicationPolicy" />
																																																<xsd:enumeration value="FindByCertificatePolicy" />
																																																<xsd:enumeration value="FindByExtension" />
																																																<xsd:enumeration value="FindByKeyUsage" />
																																																<xsd:enumeration value="FindBySubjectKeyIdentifier" />
																																															</xsd:restriction>
																																														</xsd:simpleType>
																																													</xsd:attribute>
																																													<xsd:attribute name="findValue" type="xsd:string" />
																																													<xsd:attribute name="isChainIncluded" type="boolean_type" />
																																													<xsd:attribute name="lockAttributes" type="xsd:string" />
																																													<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																													<xsd:attribute name="lockElements" type="xsd:string" />
																																													<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																													<xsd:attribute name="lockItem" type="boolean_type" />
																																												</xsd:restriction>
																																											</xsd:complexContent>
																																										</xsd:complexType>
																																									</xsd:element>
																																								</xsd:choice>
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																			</xsd:choice>
																																			<xsd:attribute name="address" type="xsd:string" use="required" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																														<xsd:attribute name="keySize">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:int">
																																	<xsd:minInclusive value="0" />
																																	<xsd:maxInclusive value="2147483647" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="keyType">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:enumeration value="SymmetricKey" />
																																	<xsd:enumeration value="AsymmetricKey" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="tokenType" type="xsd:string" />
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="localClientSettings">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:sequence />
																														<xsd:attribute name="cacheCookies" type="boolean_type" />
																														<xsd:attribute name="detectReplays" type="boolean_type" />
																														<xsd:attribute name="replayCacheSize">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:int">
																																	<xsd:minInclusive value="1" />
																																	<xsd:maxInclusive value="2147483647" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="maxClockSkew">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="maxCookieCachingTime">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="replayWindow">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="sessionKeyRenewalInterval">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="sessionKeyRolloverInterval">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="reconnectTransportOnFailure" type="boolean_type" />
																														<xsd:attribute name="timestampValidityDuration">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="cookieRenewalThresholdPercentage">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:int">
																																	<xsd:minInclusive value="0" />
																																	<xsd:maxInclusive value="100" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="localServiceSettings">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:sequence />
																														<xsd:attribute name="detectReplays" type="boolean_type" />
																														<xsd:attribute name="issuedCookieLifetime">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="maxStatefulNegotiations">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:int">
																																	<xsd:minInclusive value="0" />
																																	<xsd:maxInclusive value="2147483647" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="replayCacheSize">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:int">
																																	<xsd:minInclusive value="1" />
																																	<xsd:maxInclusive value="2147483647" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="maxClockSkew">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="negotiationTimeout">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="replayWindow">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="inactivityTimeout">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="sessionKeyRenewalInterval">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="sessionKeyRolloverInterval">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="reconnectTransportOnFailure" type="boolean_type" />
																														<xsd:attribute name="maxPendingSessions">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:int">
																																	<xsd:minInclusive value="1" />
																																	<xsd:maxInclusive value="2147483647" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="maxCachedCookies">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:int">
																																	<xsd:minInclusive value="0" />
																																	<xsd:maxInclusive value="2147483647" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="timestampValidityDuration">
																															<xsd:simpleType>
																																<xsd:restriction base="xsd:string">
																																	<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																																</xsd:restriction>
																															</xsd:simpleType>
																														</xsd:attribute>
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																									</xsd:choice>
																									<xsd:attribute name="defaultAlgorithmSuite" type="xsd:string" />
																									<xsd:attribute name="allowSerializedSigningTokenOnReply" type="boolean_type" />
																									<xsd:attribute name="authenticationMode">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="AnonymousForCertificate" />
																												<xsd:enumeration value="AnonymousForSslNegotiated" />
																												<xsd:enumeration value="CertificateOverTransport" />
																												<xsd:enumeration value="IssuedToken" />
																												<xsd:enumeration value="IssuedTokenForCertificate" />
																												<xsd:enumeration value="IssuedTokenForSslNegotiated" />
																												<xsd:enumeration value="IssuedTokenOverTransport" />
																												<xsd:enumeration value="Kerberos" />
																												<xsd:enumeration value="KerberosOverTransport" />
																												<xsd:enumeration value="MutualCertificate" />
																												<xsd:enumeration value="MutualCertificateDuplex" />
																												<xsd:enumeration value="MutualSslNegotiated" />
																												<xsd:enumeration value="SecureConversation" />
																												<xsd:enumeration value="SspiNegotiated" />
																												<xsd:enumeration value="UserNameForCertificate" />
																												<xsd:enumeration value="UserNameForSslNegotiated" />
																												<xsd:enumeration value="UserNameOverTransport" />
																												<xsd:enumeration value="SspiNegotiatedOverTransport" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="requireDerivedKeys" type="boolean_type" />
																									<xsd:attribute name="securityHeaderLayout">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="Strict" />
																												<xsd:enumeration value="Lax" />
																												<xsd:enumeration value="LaxTimestampFirst" />
																												<xsd:enumeration value="LaxTimestampLast" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="includeTimestamp" type="boolean_type" />
																									<xsd:attribute name="keyEntropyMode">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="ClientEntropy" />
																												<xsd:enumeration value="ServerEntropy" />
																												<xsd:enumeration value="CombinedEntropy" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="messageProtectionOrder">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="SignBeforeEncrypt" />
																												<xsd:enumeration value="SignBeforeEncryptAndEncryptSignature" />
																												<xsd:enumeration value="EncryptBeforeSign" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="messageSecurityVersion" type="xsd:string" />
																									<xsd:attribute name="requireSecurityContextCancellation" type="boolean_type" />
																									<xsd:attribute name="requireSignatureConfirmation" type="boolean_type" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																					<xsd:element name="issuedTokenParameters">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:choice minOccurs="0" maxOccurs="unbounded">
																										<xsd:element name="additionalRequestParameters">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="xmlElement">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="xmlElement" type="xsd:string" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="claimTypeRequirements">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="add">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="claimType" type="xsd:string" use="required" />
																																			<xsd:attribute name="isOptional" type="boolean_type" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="remove">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="claimType" type="xsd:string" use="required" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="clear">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType" />
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="issuer">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="headers">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:any processContents="skip" />
																																			</xsd:choice>
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="identity">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:element name="userPrincipalName">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="servicePrincipalName">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="dns">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="rsa">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="certificate">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="encodedValue" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="certificateReference">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="storeName">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="AddressBook" />
																																											<xsd:enumeration value="AuthRoot" />
																																											<xsd:enumeration value="CertificateAuthority" />
																																											<xsd:enumeration value="Disallowed" />
																																											<xsd:enumeration value="My" />
																																											<xsd:enumeration value="Root" />
																																											<xsd:enumeration value="TrustedPeople" />
																																											<xsd:enumeration value="TrustedPublisher" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="storeLocation">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="CurrentUser" />
																																											<xsd:enumeration value="LocalMachine" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="x509FindType">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="FindByThumbprint" />
																																											<xsd:enumeration value="FindBySubjectName" />
																																											<xsd:enumeration value="FindBySubjectDistinguishedName" />
																																											<xsd:enumeration value="FindByIssuerName" />
																																											<xsd:enumeration value="FindByIssuerDistinguishedName" />
																																											<xsd:enumeration value="FindBySerialNumber" />
																																											<xsd:enumeration value="FindByTimeValid" />
																																											<xsd:enumeration value="FindByTimeNotYetValid" />
																																											<xsd:enumeration value="FindByTimeExpired" />
																																											<xsd:enumeration value="FindByTemplateName" />
																																											<xsd:enumeration value="FindByApplicationPolicy" />
																																											<xsd:enumeration value="FindByCertificatePolicy" />
																																											<xsd:enumeration value="FindByExtension" />
																																											<xsd:enumeration value="FindByKeyUsage" />
																																											<xsd:enumeration value="FindBySubjectKeyIdentifier" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="findValue" type="xsd:string" />
																																								<xsd:attribute name="isChainIncluded" type="boolean_type" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																			</xsd:choice>
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																														<xsd:attribute name="binding" type="xsd:string" />
																														<xsd:attribute name="bindingConfiguration" type="xsd:string" />
																														<xsd:attribute name="address" type="xsd:string" use="required" />
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="issuerMetadata">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="headers">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:any processContents="skip" />
																																			</xsd:choice>
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="identity">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:element name="userPrincipalName">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="servicePrincipalName">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="dns">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="rsa">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="certificate">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="encodedValue" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="certificateReference">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="storeName">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="AddressBook" />
																																											<xsd:enumeration value="AuthRoot" />
																																											<xsd:enumeration value="CertificateAuthority" />
																																											<xsd:enumeration value="Disallowed" />
																																											<xsd:enumeration value="My" />
																																											<xsd:enumeration value="Root" />
																																											<xsd:enumeration value="TrustedPeople" />
																																											<xsd:enumeration value="TrustedPublisher" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="storeLocation">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="CurrentUser" />
																																											<xsd:enumeration value="LocalMachine" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="x509FindType">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="FindByThumbprint" />
																																											<xsd:enumeration value="FindBySubjectName" />
																																											<xsd:enumeration value="FindBySubjectDistinguishedName" />
																																											<xsd:enumeration value="FindByIssuerName" />
																																											<xsd:enumeration value="FindByIssuerDistinguishedName" />
																																											<xsd:enumeration value="FindBySerialNumber" />
																																											<xsd:enumeration value="FindByTimeValid" />
																																											<xsd:enumeration value="FindByTimeNotYetValid" />
																																											<xsd:enumeration value="FindByTimeExpired" />
																																											<xsd:enumeration value="FindByTemplateName" />
																																											<xsd:enumeration value="FindByApplicationPolicy" />
																																											<xsd:enumeration value="FindByCertificatePolicy" />
																																											<xsd:enumeration value="FindByExtension" />
																																											<xsd:enumeration value="FindByKeyUsage" />
																																											<xsd:enumeration value="FindBySubjectKeyIdentifier" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="findValue" type="xsd:string" />
																																								<xsd:attribute name="isChainIncluded" type="boolean_type" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																			</xsd:choice>
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																														<xsd:attribute name="address" type="xsd:string" use="required" />
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																									</xsd:choice>
																									<xsd:attribute name="keySize">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="keyType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="SymmetricKey" />
																												<xsd:enumeration value="AsymmetricKey" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="tokenType" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																					<xsd:element name="localClientSettings">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="cacheCookies" type="boolean_type" />
																									<xsd:attribute name="detectReplays" type="boolean_type" />
																									<xsd:attribute name="replayCacheSize">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="1" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxClockSkew">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxCookieCachingTime">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="replayWindow">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="sessionKeyRenewalInterval">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="sessionKeyRolloverInterval">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="reconnectTransportOnFailure" type="boolean_type" />
																									<xsd:attribute name="timestampValidityDuration">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="cookieRenewalThresholdPercentage">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="100" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																					<xsd:element name="localServiceSettings">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="detectReplays" type="boolean_type" />
																									<xsd:attribute name="issuedCookieLifetime">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxStatefulNegotiations">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="replayCacheSize">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="1" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxClockSkew">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="negotiationTimeout">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="replayWindow">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="inactivityTimeout">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="sessionKeyRenewalInterval">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="sessionKeyRolloverInterval">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="reconnectTransportOnFailure" type="boolean_type" />
																									<xsd:attribute name="maxPendingSessions">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="1" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxCachedCookies">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="timestampValidityDuration">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="defaultAlgorithmSuite" type="xsd:string" />
																				<xsd:attribute name="allowSerializedSigningTokenOnReply" type="boolean_type" />
																				<xsd:attribute name="authenticationMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="AnonymousForCertificate" />
																							<xsd:enumeration value="AnonymousForSslNegotiated" />
																							<xsd:enumeration value="CertificateOverTransport" />
																							<xsd:enumeration value="IssuedToken" />
																							<xsd:enumeration value="IssuedTokenForCertificate" />
																							<xsd:enumeration value="IssuedTokenForSslNegotiated" />
																							<xsd:enumeration value="IssuedTokenOverTransport" />
																							<xsd:enumeration value="Kerberos" />
																							<xsd:enumeration value="KerberosOverTransport" />
																							<xsd:enumeration value="MutualCertificate" />
																							<xsd:enumeration value="MutualCertificateDuplex" />
																							<xsd:enumeration value="MutualSslNegotiated" />
																							<xsd:enumeration value="SecureConversation" />
																							<xsd:enumeration value="SspiNegotiated" />
																							<xsd:enumeration value="UserNameForCertificate" />
																							<xsd:enumeration value="UserNameForSslNegotiated" />
																							<xsd:enumeration value="UserNameOverTransport" />
																							<xsd:enumeration value="SspiNegotiatedOverTransport" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="requireDerivedKeys" type="boolean_type" />
																				<xsd:attribute name="securityHeaderLayout">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Strict" />
																							<xsd:enumeration value="Lax" />
																							<xsd:enumeration value="LaxTimestampFirst" />
																							<xsd:enumeration value="LaxTimestampLast" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="includeTimestamp" type="boolean_type" />
																				<xsd:attribute name="keyEntropyMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="ClientEntropy" />
																							<xsd:enumeration value="ServerEntropy" />
																							<xsd:enumeration value="CombinedEntropy" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="messageProtectionOrder">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="SignBeforeEncrypt" />
																							<xsd:enumeration value="SignBeforeEncryptAndEncryptSignature" />
																							<xsd:enumeration value="EncryptBeforeSign" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="messageSecurityVersion" type="xsd:string" />
																				<xsd:attribute name="requireSecurityContextCancellation" type="boolean_type" />
																				<xsd:attribute name="requireSignatureConfirmation" type="boolean_type" />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="sslStreamSecurity">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="requireClientCertificate" type="boolean_type" />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="tcpTransport">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="connectionPoolSettings">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="groupName" type="xsd:string" />
																									<xsd:attribute name="leaseTimeout">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="idleTimeout">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxOutboundConnectionsPerEndpoint">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="listenBacklog">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="portSharingEnabled" type="boolean_type" />
																				<xsd:attribute name="teredoEnabled" type="boolean_type" />
																				<xsd:attribute name="connectionBufferSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="hostNameComparisonMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="StrongWildcard" />
																							<xsd:enumeration value="Exact" />
																							<xsd:enumeration value="WeakWildcard" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="channelInitializationTimeout">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBufferSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxPendingConnections">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxOutputDelay">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxPendingAccepts">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="transferMode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Buffered" />
																							<xsd:enumeration value="Streamed" />
																							<xsd:enumeration value="StreamedRequest" />
																							<xsd:enumeration value="StreamedResponse" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="manualAddressing" type="boolean_type" />
																				<xsd:attribute name="maxBufferPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxReceivedMessageSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:long">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="9223372036854775807" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="textMessageEncoding">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="readerQuotas">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="maxDepth">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxStringContentLength">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxArrayLength">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxBytesPerRead">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="maxNameTableCharCount">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:int">
																												<xsd:minInclusive value="0" />
																												<xsd:maxInclusive value="2147483647" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="maxReadPoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxWritePoolSize">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="1" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="messageVersion" type="xsd:string" />
																				<xsd:attribute name="writeEncoding" type="xsd:string" />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="windowsStreamSecurity">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="protectionLevel">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Sign" />
																							<xsd:enumeration value="EncryptAndSign" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="transactionFlow">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="transactionProtocol" type="xsd:string" />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="unrecognizedPolicyAssertions">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="useManagedPresentation">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="msmqIntegrationBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="transport">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="msmqAuthenticationMode">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="WindowsDomain" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqEncryptionAlgorithm">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="RC4Stream" />
																												<xsd:enumeration value="Aes" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqProtectionLevel">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Sign" />
																												<xsd:enumeration value="EncryptAndSign" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqSecureHashAlgorithm">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="MD5" />
																												<xsd:enumeration value="Sha1" />
																												<xsd:enumeration value="Sha256" />
																												<xsd:enumeration value="Sha512" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Transport" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="serializationFormat">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Xml" />
																		<xsd:enumeration value="Binary" />
																		<xsd:enumeration value="ActiveX" />
																		<xsd:enumeration value="ByteArray" />
																		<xsd:enumeration value="Stream" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="customDeadLetterQueue" type="xsd:string" />
															<xsd:attribute name="deadLetterQueue">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="None" />
																		<xsd:enumeration value="System" />
																		<xsd:enumeration value="Custom" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="durable" type="boolean_type" />
															<xsd:attribute name="exactlyOnce" type="boolean_type" />
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxRetryCycles">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveErrorHandling">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Fault" />
																		<xsd:enumeration value="Drop" />
																		<xsd:enumeration value="Reject" />
																		<xsd:enumeration value="Move" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveRetryCount">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="retryCycleDelay">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="timeToLive">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="useSourceJournal" type="boolean_type" />
															<xsd:attribute name="useMsmqTracing" type="boolean_type" />
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="netPeerTcpBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="readerQuotas">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="maxDepth">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxStringContentLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxArrayLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBytesPerRead">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxNameTableCharCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="resolver">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="custom">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:choice minOccurs="0" maxOccurs="unbounded">
																										<xsd:element name="headers">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:any processContents="skip" />
																														</xsd:choice>
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="identity">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="userPrincipalName">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="value" type="xsd:string" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="servicePrincipalName">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="value" type="xsd:string" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="dns">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="value" type="xsd:string" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="rsa">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="value" type="xsd:string" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="certificate">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="encodedValue" type="xsd:string" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="certificateReference">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="storeName">
																																				<xsd:simpleType>
																																					<xsd:restriction base="xsd:string">
																																						<xsd:enumeration value="AddressBook" />
																																						<xsd:enumeration value="AuthRoot" />
																																						<xsd:enumeration value="CertificateAuthority" />
																																						<xsd:enumeration value="Disallowed" />
																																						<xsd:enumeration value="My" />
																																						<xsd:enumeration value="Root" />
																																						<xsd:enumeration value="TrustedPeople" />
																																						<xsd:enumeration value="TrustedPublisher" />
																																					</xsd:restriction>
																																				</xsd:simpleType>
																																			</xsd:attribute>
																																			<xsd:attribute name="storeLocation">
																																				<xsd:simpleType>
																																					<xsd:restriction base="xsd:string">
																																						<xsd:enumeration value="CurrentUser" />
																																						<xsd:enumeration value="LocalMachine" />
																																					</xsd:restriction>
																																				</xsd:simpleType>
																																			</xsd:attribute>
																																			<xsd:attribute name="x509FindType">
																																				<xsd:simpleType>
																																					<xsd:restriction base="xsd:string">
																																						<xsd:enumeration value="FindByThumbprint" />
																																						<xsd:enumeration value="FindBySubjectName" />
																																						<xsd:enumeration value="FindBySubjectDistinguishedName" />
																																						<xsd:enumeration value="FindByIssuerName" />
																																						<xsd:enumeration value="FindByIssuerDistinguishedName" />
																																						<xsd:enumeration value="FindBySerialNumber" />
																																						<xsd:enumeration value="FindByTimeValid" />
																																						<xsd:enumeration value="FindByTimeNotYetValid" />
																																						<xsd:enumeration value="FindByTimeExpired" />
																																						<xsd:enumeration value="FindByTemplateName" />
																																						<xsd:enumeration value="FindByApplicationPolicy" />
																																						<xsd:enumeration value="FindByCertificatePolicy" />
																																						<xsd:enumeration value="FindByExtension" />
																																						<xsd:enumeration value="FindByKeyUsage" />
																																						<xsd:enumeration value="FindBySubjectKeyIdentifier" />
																																					</xsd:restriction>
																																				</xsd:simpleType>
																																			</xsd:attribute>
																																			<xsd:attribute name="findValue" type="xsd:string" />
																																			<xsd:attribute name="isChainIncluded" type="boolean_type" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																									</xsd:choice>
																									<xsd:attribute name="address" type="xsd:string" />
																									<xsd:attribute name="binding" type="xsd:string" />
																									<xsd:attribute name="bindingConfiguration" type="xsd:string" />
																									<xsd:attribute name="resolverType" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Auto" />
																							<xsd:enumeration value="Pnrp" />
																							<xsd:enumeration value="Custom" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="referralPolicy">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="Service" />
																							<xsd:enumeration value="Share" />
																							<xsd:enumeration value="DoNotShare" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="transport">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="credentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="Password" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Transport" />
																							<xsd:enumeration value="Message" />
																							<xsd:enumeration value="TransportWithMessageCredential" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="listenIPAddress" type="xsd:string" />
															<xsd:attribute name="maxBufferPoolSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="16384" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="port">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="65535" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="netMsmqBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="readerQuotas">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="maxDepth">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxStringContentLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxArrayLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBytesPerRead">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxNameTableCharCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="transport">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="msmqAuthenticationMode">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="WindowsDomain" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqEncryptionAlgorithm">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="RC4Stream" />
																												<xsd:enumeration value="Aes" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqProtectionLevel">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Sign" />
																												<xsd:enumeration value="EncryptAndSign" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="msmqSecureHashAlgorithm">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="MD5" />
																												<xsd:enumeration value="Sha1" />
																												<xsd:enumeration value="Sha256" />
																												<xsd:enumeration value="Sha512" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																					<xsd:element name="message">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="clientCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Windows" />
																												<xsd:enumeration value="UserName" />
																												<xsd:enumeration value="Certificate" />
																												<xsd:enumeration value="IssuedToken" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="algorithmSuite" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Transport" />
																							<xsd:enumeration value="Message" />
																							<xsd:enumeration value="Both" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="queueTransferProtocol">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Native" />
																		<xsd:enumeration value="Srmp" />
																		<xsd:enumeration value="SrmpSecure" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferPoolSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="useActiveDirectory" type="boolean_type" />
															<xsd:attribute name="customDeadLetterQueue" type="xsd:string" />
															<xsd:attribute name="deadLetterQueue">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="None" />
																		<xsd:enumeration value="System" />
																		<xsd:enumeration value="Custom" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="durable" type="boolean_type" />
															<xsd:attribute name="exactlyOnce" type="boolean_type" />
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxRetryCycles">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveErrorHandling">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Fault" />
																		<xsd:enumeration value="Drop" />
																		<xsd:enumeration value="Reject" />
																		<xsd:enumeration value="Move" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveRetryCount">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="retryCycleDelay">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="timeToLive">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="useSourceJournal" type="boolean_type" />
															<xsd:attribute name="useMsmqTracing" type="boolean_type" />
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="netNamedPipeBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="readerQuotas">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="maxDepth">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxStringContentLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxArrayLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBytesPerRead">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxNameTableCharCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="transport">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="protectionLevel">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Sign" />
																												<xsd:enumeration value="EncryptAndSign" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Transport" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="transactionFlow" type="boolean_type" />
															<xsd:attribute name="transferMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Buffered" />
																		<xsd:enumeration value="Streamed" />
																		<xsd:enumeration value="StreamedRequest" />
																		<xsd:enumeration value="StreamedResponse" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="transactionProtocol" type="xsd:string" />
															<xsd:attribute name="hostNameComparisonMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="StrongWildcard" />
																		<xsd:enumeration value="Exact" />
																		<xsd:enumeration value="WeakWildcard" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferPoolSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxConnections">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="netTcpBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="readerQuotas">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="maxDepth">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxStringContentLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxArrayLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBytesPerRead">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxNameTableCharCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="reliableSession">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="enabled" type="boolean_type" />
																				<xsd:attribute name="ordered" type="boolean_type" />
																				<xsd:attribute name="inactivityTimeout">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="transport">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="clientCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Windows" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="protectionLevel">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Sign" />
																												<xsd:enumeration value="EncryptAndSign" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																					<xsd:element name="message">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="clientCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Windows" />
																												<xsd:enumeration value="UserName" />
																												<xsd:enumeration value="Certificate" />
																												<xsd:enumeration value="IssuedToken" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="algorithmSuite" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Transport" />
																							<xsd:enumeration value="Message" />
																							<xsd:enumeration value="TransportWithMessageCredential" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="transactionFlow" type="boolean_type" />
															<xsd:attribute name="transferMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Buffered" />
																		<xsd:enumeration value="Streamed" />
																		<xsd:enumeration value="StreamedRequest" />
																		<xsd:enumeration value="StreamedResponse" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="transactionProtocol" type="xsd:string" />
															<xsd:attribute name="hostNameComparisonMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="StrongWildcard" />
																		<xsd:enumeration value="Exact" />
																		<xsd:enumeration value="WeakWildcard" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="listenBacklog">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferPoolSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxConnections">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="portSharingEnabled" type="boolean_type" />
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="wsFederationHttpBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="message">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:choice minOccurs="0" maxOccurs="unbounded">
																										<xsd:element name="claimTypeRequirements">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="add">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="claimType" type="xsd:string" use="required" />
																																			<xsd:attribute name="isOptional" type="boolean_type" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="remove">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="claimType" type="xsd:string" use="required" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="clear">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType" />
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="issuer">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="headers">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:any processContents="skip" />
																																			</xsd:choice>
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="identity">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:element name="userPrincipalName">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="servicePrincipalName">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="dns">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="rsa">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="certificate">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="encodedValue" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="certificateReference">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="storeName">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="AddressBook" />
																																											<xsd:enumeration value="AuthRoot" />
																																											<xsd:enumeration value="CertificateAuthority" />
																																											<xsd:enumeration value="Disallowed" />
																																											<xsd:enumeration value="My" />
																																											<xsd:enumeration value="Root" />
																																											<xsd:enumeration value="TrustedPeople" />
																																											<xsd:enumeration value="TrustedPublisher" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="storeLocation">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="CurrentUser" />
																																											<xsd:enumeration value="LocalMachine" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="x509FindType">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="FindByThumbprint" />
																																											<xsd:enumeration value="FindBySubjectName" />
																																											<xsd:enumeration value="FindBySubjectDistinguishedName" />
																																											<xsd:enumeration value="FindByIssuerName" />
																																											<xsd:enumeration value="FindByIssuerDistinguishedName" />
																																											<xsd:enumeration value="FindBySerialNumber" />
																																											<xsd:enumeration value="FindByTimeValid" />
																																											<xsd:enumeration value="FindByTimeNotYetValid" />
																																											<xsd:enumeration value="FindByTimeExpired" />
																																											<xsd:enumeration value="FindByTemplateName" />
																																											<xsd:enumeration value="FindByApplicationPolicy" />
																																											<xsd:enumeration value="FindByCertificatePolicy" />
																																											<xsd:enumeration value="FindByExtension" />
																																											<xsd:enumeration value="FindByKeyUsage" />
																																											<xsd:enumeration value="FindBySubjectKeyIdentifier" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="findValue" type="xsd:string" />
																																								<xsd:attribute name="isChainIncluded" type="boolean_type" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																			</xsd:choice>
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																														<xsd:attribute name="binding" type="xsd:string" />
																														<xsd:attribute name="bindingConfiguration" type="xsd:string" />
																														<xsd:attribute name="address" type="xsd:string" use="required" />
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="issuerMetadata">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="headers">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:any processContents="skip" />
																																			</xsd:choice>
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																															<xsd:element name="identity">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:choice minOccurs="0" maxOccurs="unbounded">
																																				<xsd:element name="userPrincipalName">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="servicePrincipalName">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="dns">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="rsa">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="value" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="certificate">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="encodedValue" type="xsd:string" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																				<xsd:element name="certificateReference">
																																					<xsd:complexType>
																																						<xsd:complexContent>
																																							<xsd:restriction base="xsd:anyType">
																																								<xsd:sequence />
																																								<xsd:attribute name="storeName">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="AddressBook" />
																																											<xsd:enumeration value="AuthRoot" />
																																											<xsd:enumeration value="CertificateAuthority" />
																																											<xsd:enumeration value="Disallowed" />
																																											<xsd:enumeration value="My" />
																																											<xsd:enumeration value="Root" />
																																											<xsd:enumeration value="TrustedPeople" />
																																											<xsd:enumeration value="TrustedPublisher" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="storeLocation">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="CurrentUser" />
																																											<xsd:enumeration value="LocalMachine" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="x509FindType">
																																									<xsd:simpleType>
																																										<xsd:restriction base="xsd:string">
																																											<xsd:enumeration value="FindByThumbprint" />
																																											<xsd:enumeration value="FindBySubjectName" />
																																											<xsd:enumeration value="FindBySubjectDistinguishedName" />
																																											<xsd:enumeration value="FindByIssuerName" />
																																											<xsd:enumeration value="FindByIssuerDistinguishedName" />
																																											<xsd:enumeration value="FindBySerialNumber" />
																																											<xsd:enumeration value="FindByTimeValid" />
																																											<xsd:enumeration value="FindByTimeNotYetValid" />
																																											<xsd:enumeration value="FindByTimeExpired" />
																																											<xsd:enumeration value="FindByTemplateName" />
																																											<xsd:enumeration value="FindByApplicationPolicy" />
																																											<xsd:enumeration value="FindByCertificatePolicy" />
																																											<xsd:enumeration value="FindByExtension" />
																																											<xsd:enumeration value="FindByKeyUsage" />
																																											<xsd:enumeration value="FindBySubjectKeyIdentifier" />
																																										</xsd:restriction>
																																									</xsd:simpleType>
																																								</xsd:attribute>
																																								<xsd:attribute name="findValue" type="xsd:string" />
																																								<xsd:attribute name="isChainIncluded" type="boolean_type" />
																																								<xsd:attribute name="lockAttributes" type="xsd:string" />
																																								<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																								<xsd:attribute name="lockElements" type="xsd:string" />
																																								<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																								<xsd:attribute name="lockItem" type="boolean_type" />
																																							</xsd:restriction>
																																						</xsd:complexContent>
																																					</xsd:complexType>
																																				</xsd:element>
																																			</xsd:choice>
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																														<xsd:attribute name="address" type="xsd:string" use="required" />
																														<xsd:attribute name="lockAttributes" type="xsd:string" />
																														<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																														<xsd:attribute name="lockElements" type="xsd:string" />
																														<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																														<xsd:attribute name="lockItem" type="boolean_type" />
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																										<xsd:element name="tokenRequestParameters">
																											<xsd:complexType>
																												<xsd:complexContent>
																													<xsd:restriction base="xsd:anyType">
																														<xsd:choice minOccurs="0" maxOccurs="unbounded">
																															<xsd:element name="xmlElement">
																																<xsd:complexType>
																																	<xsd:complexContent>
																																		<xsd:restriction base="xsd:anyType">
																																			<xsd:sequence />
																																			<xsd:attribute name="xmlElement" type="xsd:string" />
																																			<xsd:attribute name="lockAttributes" type="xsd:string" />
																																			<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																																			<xsd:attribute name="lockElements" type="xsd:string" />
																																			<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																																			<xsd:attribute name="lockItem" type="boolean_type" />
																																		</xsd:restriction>
																																	</xsd:complexContent>
																																</xsd:complexType>
																															</xsd:element>
																														</xsd:choice>
																													</xsd:restriction>
																												</xsd:complexContent>
																											</xsd:complexType>
																										</xsd:element>
																									</xsd:choice>
																									<xsd:attribute name="algorithmSuite" type="xsd:string" />
																									<xsd:attribute name="issuedKeyType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="SymmetricKey" />
																												<xsd:enumeration value="AsymmetricKey" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="issuedTokenType" type="xsd:string" />
																									<xsd:attribute name="negotiateServiceCredential" type="boolean_type" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Message" />
																							<xsd:enumeration value="TransportWithMessageCredential" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="readerQuotas">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="maxDepth">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxStringContentLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxArrayLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBytesPerRead">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxNameTableCharCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="reliableSession">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="enabled" type="boolean_type" />
																				<xsd:attribute name="ordered" type="boolean_type" />
																				<xsd:attribute name="inactivityTimeout">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="privacyNoticeAt" type="xsd:string" />
															<xsd:attribute name="privacyNoticeVersion">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:int">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="bypassProxyOnLocal" type="boolean_type" />
															<xsd:attribute name="transactionFlow" type="boolean_type" />
															<xsd:attribute name="hostNameComparisonMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="StrongWildcard" />
																		<xsd:enumeration value="Exact" />
																		<xsd:enumeration value="WeakWildcard" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferPoolSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="messageEncoding">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Text" />
																		<xsd:enumeration value="Mtom" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="proxyAddress" type="xsd:string" />
															<xsd:attribute name="textEncoding" type="xsd:string" />
															<xsd:attribute name="useDefaultWebProxy" type="boolean_type" />
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="wsHttpBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="transport">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="clientCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Basic" />
																												<xsd:enumeration value="Digest" />
																												<xsd:enumeration value="Ntlm" />
																												<xsd:enumeration value="Windows" />
																												<xsd:enumeration value="Certificate" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="proxyCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Basic" />
																												<xsd:enumeration value="Digest" />
																												<xsd:enumeration value="Ntlm" />
																												<xsd:enumeration value="Windows" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="realm" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																					<xsd:element name="message">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="establishSecurityContext" type="boolean_type" />
																									<xsd:attribute name="clientCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Windows" />
																												<xsd:enumeration value="UserName" />
																												<xsd:enumeration value="Certificate" />
																												<xsd:enumeration value="IssuedToken" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="negotiateServiceCredential" type="boolean_type" />
																									<xsd:attribute name="algorithmSuite" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Transport" />
																							<xsd:enumeration value="Message" />
																							<xsd:enumeration value="TransportWithMessageCredential" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="readerQuotas">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="maxDepth">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxStringContentLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxArrayLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBytesPerRead">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxNameTableCharCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="reliableSession">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="enabled" type="boolean_type" />
																				<xsd:attribute name="ordered" type="boolean_type" />
																				<xsd:attribute name="inactivityTimeout">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="allowCookies" type="boolean_type" />
															<xsd:attribute name="bypassProxyOnLocal" type="boolean_type" />
															<xsd:attribute name="transactionFlow" type="boolean_type" />
															<xsd:attribute name="hostNameComparisonMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="StrongWildcard" />
																		<xsd:enumeration value="Exact" />
																		<xsd:enumeration value="WeakWildcard" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferPoolSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="messageEncoding">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Text" />
																		<xsd:enumeration value="Mtom" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="proxyAddress" type="xsd:string" />
															<xsd:attribute name="textEncoding" type="xsd:string" />
															<xsd:attribute name="useDefaultWebProxy" type="boolean_type" />
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
						<xsd:element name="wsDualHttpBinding">
							<xsd:complexType>
								<xsd:complexContent>
									<xsd:restriction base="xsd:anyType">
										<xsd:choice minOccurs="0" maxOccurs="unbounded">
											<xsd:element name="binding">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:choice minOccurs="0" maxOccurs="unbounded">
																<xsd:element name="readerQuotas">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="maxDepth">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxStringContentLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxArrayLength">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxBytesPerRead">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="maxNameTableCharCount">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:int">
																							<xsd:minInclusive value="0" />
																							<xsd:maxInclusive value="2147483647" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="reliableSession">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:sequence />
																				<xsd:attribute name="ordered" type="boolean_type" />
																				<xsd:attribute name="inactivityTimeout">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
																<xsd:element name="security">
																	<xsd:complexType>
																		<xsd:complexContent>
																			<xsd:restriction base="xsd:anyType">
																				<xsd:choice minOccurs="0" maxOccurs="unbounded">
																					<xsd:element name="message">
																						<xsd:complexType>
																							<xsd:complexContent>
																								<xsd:restriction base="xsd:anyType">
																									<xsd:sequence />
																									<xsd:attribute name="clientCredentialType">
																										<xsd:simpleType>
																											<xsd:restriction base="xsd:string">
																												<xsd:enumeration value="None" />
																												<xsd:enumeration value="Windows" />
																												<xsd:enumeration value="UserName" />
																												<xsd:enumeration value="Certificate" />
																												<xsd:enumeration value="IssuedToken" />
																											</xsd:restriction>
																										</xsd:simpleType>
																									</xsd:attribute>
																									<xsd:attribute name="negotiateServiceCredential" type="boolean_type" />
																									<xsd:attribute name="algorithmSuite" type="xsd:string" />
																									<xsd:attribute name="lockAttributes" type="xsd:string" />
																									<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																									<xsd:attribute name="lockElements" type="xsd:string" />
																									<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																									<xsd:attribute name="lockItem" type="boolean_type" />
																								</xsd:restriction>
																							</xsd:complexContent>
																						</xsd:complexType>
																					</xsd:element>
																				</xsd:choice>
																				<xsd:attribute name="mode">
																					<xsd:simpleType>
																						<xsd:restriction base="xsd:string">
																							<xsd:enumeration value="None" />
																							<xsd:enumeration value="Message" />
																						</xsd:restriction>
																					</xsd:simpleType>
																				</xsd:attribute>
																				<xsd:attribute name="lockAttributes" type="xsd:string" />
																				<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
																				<xsd:attribute name="lockElements" type="xsd:string" />
																				<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
																				<xsd:attribute name="lockItem" type="boolean_type" />
																			</xsd:restriction>
																		</xsd:complexContent>
																	</xsd:complexType>
																</xsd:element>
															</xsd:choice>
															<xsd:attribute name="bypassProxyOnLocal" type="boolean_type" />
															<xsd:attribute name="clientBaseAddress" type="xsd:string" />
															<xsd:attribute name="transactionFlow" type="boolean_type" />
															<xsd:attribute name="hostNameComparisonMode">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="StrongWildcard" />
																		<xsd:enumeration value="Exact" />
																		<xsd:enumeration value="WeakWildcard" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxBufferPoolSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="0" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="maxReceivedMessageSize">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:long">
																		<xsd:minInclusive value="1" />
																		<xsd:maxInclusive value="9223372036854775807" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="messageEncoding">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:enumeration value="Text" />
																		<xsd:enumeration value="Mtom" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="proxyAddress" type="xsd:string" />
															<xsd:attribute name="textEncoding" type="xsd:string" />
															<xsd:attribute name="useDefaultWebProxy" type="boolean_type" />
															<xsd:attribute name="name" use="required">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:minLength value="1" />
																		<xsd:maxLength value="2147483647" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="closeTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="openTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="receiveTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="sendTimeout">
																<xsd:simpleType>
																	<xsd:restriction base="xsd:string">
																		<xsd:pattern value="([0-9.]+:){0,1}([0-9]+:){0,1}[0-9.]+" />
																	</xsd:restriction>
																</xsd:simpleType>
															</xsd:attribute>
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="remove">
												<xsd:complexType>
													<xsd:complexContent>
														<xsd:restriction base="xsd:anyType">
															<xsd:sequence />
															<xsd:attribute name="name" type="xsd:string" use="required" />
															<xsd:attribute name="lockAttributes" type="xsd:string" />
															<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
															<xsd:attribute name="lockElements" type="xsd:string" />
															<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
															<xsd:attribute name="lockItem" type="boolean_type" />
														</xsd:restriction>
													</xsd:complexContent>
												</xsd:complexType>
											</xsd:element>
											<xsd:element name="clear" type="xsd:anyType" />
										</xsd:choice>
										<xsd:attribute name="lockAttributes" type="xsd:string" />
										<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
										<xsd:attribute name="lockElements" type="xsd:string" />
										<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
										<xsd:attribute name="lockItem" type="boolean_type" />
									</xsd:restriction>
								</xsd:complexContent>
							</xsd:complexType>
						</xsd:element>
					</xsd:choice>
					<xsd:attribute name="lockAttributes" type="xsd:string" />
					<xsd:attribute name="lockAllAttributesExcept" type="xsd:string" />
					<xsd:attribute name="lockElements" type="xsd:string" />
					<xsd:attribute name="lockAllElementsExcept" type="xsd:string" />
					<xsd:attribute name="lockItem" type="boolean_type" />
				</xsd:restriction>
			</xsd:complexContent>
		</xsd:complexType>
	</xsd:element>
	<xsd:simpleType name="Infinite">
		<xsd:restriction base="xsd:string">
			<xsd:enumeration value="Infinite" />
		</xsd:restriction>
	</xsd:simpleType>
	<xsd:simpleType name="boolean_type">
		<xsd:restriction base="xsd:NMTOKEN">
			<xsd:enumeration value="false" />
			<xsd:enumeration value="true" />
			<xsd:enumeration value="True" />
			<xsd:enumeration value="False" />
		</xsd:restriction>
	</xsd:simpleType>
	<xsd:simpleType name="small_boolean_type">
		<xsd:restriction base="xsd:NMTOKEN">
			<xsd:enumeration value="false" />
			<xsd:enumeration value="true" />
		</xsd:restriction>
	</xsd:simpleType>
	<xsd:simpleType name="Infinite_or_int">
		<xsd:union memberTypes="Infinite xsd:int" />
	</xsd:simpleType>
</xsd:schema>'


